-- fourbit counter; behavioral description

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity counter4bit is
  port (
    clk    : in  std_logic;
    rst    : in  std_logic;
    up     : in  std_logic;
    output : out std_logic_vector(3 downto 0)
  );
end counter4bit;


architecture my_behavioral_unsigned of counter4bit is

  -- use a 4 bit unsigned instead of an integer.
  signal count : unsigned(3 downto 0);
    
begin

  process(clk, rst)
  begin
    if (rst = '1') then
      count <= "0000";
    elsif (rising_edge(clk)) then
      -- notice here that we can just add or subtract 1            
      if (up = '1') then
          count <= count + 1;
      else
          count <= count - 1;
      end if;
    end if;
  end process;

  output <= std_logic_vector(count);
       
end my_behavioral_unsigned;
